using System;
using BBN.DAML.Vocabulary;

namespace BBN.DAML
{
	/// <summary>
	/// 
	/// </summary>
	public class DAMLDisjointImpl : DAMLCommonImpl, DAMLDisjoint
	{

		/**
		 * Constructor, takes the URI for this disjoint, and the underlying
		 * model it will be attached to.
		 *
		 * @param uri The URI of the disjoint
		 * @param store Reference to the DAML store that will contain statements about this DAML disjoint.
		 * @param vocabulary Reference to the DAML vocabulary used by this disjoint.
		 */
		public DAMLDisjointImpl( string uri, DAMLModel store, DAMLVocabulary vocabulary ) 
			: base( uri, store, vocabulary )
		{
		}



		/**
		 * Constructor, takes the name and namespace for this disjoint, and the underlying
		 * model it will be attached to.
		 *
		 * @param namespace The namespace the disjoint inhabits, or null
		 * @param name The name of the disjoint
		 * @param store Reference to the DAML store that will contain statements about this DAML disjoint.
		 * @param vocabulary Reference to the DAML vocabulary used by this disjoint.
		 */
		public DAMLDisjointImpl( string ns, string name, DAMLModel store, DAMLVocabulary vocabulary ) 
			: base( ns, name, store, vocabulary )
		{
		}




		// External signature methods
		//////////////////////////////////


		/**
		 * Answer a key that can be used to index collections of this DAML disjoint for
		 * easy access by iterators.  Package access only.
		 *
		 * @return a key object.
		 */
		public override object GetKey() 
		{
			return DAML_OIL_2000_12._Disjoint.GetURI();
		}


		// Internal implementation methods
		//////////////////////////////////




		//==============================================================================
		// Inner class definitions
		//==============================================================================

	}
}
