using System;
using System.Collections;
using BBN.RDF; 

namespace BBN.RDF.Common
{
	/*public class ContainerImpl : ResourceImpl, Container
	{
		static NodeEnumeratorFactory enumeratorFactory;
		/// <summary>
		/// Static constructor
		/// </summary>
		static ContainerImpl()
		{
			enumeratorFactory = new ContNodeEnumeratorFactoryImpl();
		}
		public ContainerImpl(Model model) : base(model)
		{}
		public ContainerImpl(string uri, Model model) : base(uri, model)
		{}
		public ContainerImpl(Resource r, Model model) : base(r, model)
		{}
		public Container Add(RDFNode n)
		{
			int i = Count;
			AddProperty(Vocabulary.RDF.li(i+1), n);
			return this;
		}
		public Container Add(bool o)
		{
			return Add(new LiteralImpl(o));
		}
		public Container Add(long o)
		{
			return Add(new LiteralImpl(o));
		}
		public Container Add(char o)
		{
			return Add(new LiteralImpl(o));
		}
		public Container Add(float o)
		{
			return Add(new LiteralImpl(o));
		}
		public Container Add(double o)
		{
			return Add(new LiteralImpl(o));
		}
		public Container Add(string o)
		{
			return Add(new LiteralImpl(o));
		}
		public Container Add(string o, string l)
		{
			return Add(new LiteralImpl(o, l));
		}
		public Container Add(object o)
		{
			return Add(new LiteralImpl(o));
		}
		public bool Contains(RDFNode n)
		{
			return ((Model)model).ContainerContains(this, n);
		}
		public bool Contains(bool o)
		{
			return Contains(new LiteralImpl(o));
		}
		public bool Contains(long o)
		{
			return Contains(new LiteralImpl(o));
		}
		public bool Contains(char o)
		{
			return Contains(new LiteralImpl(o));
		}
		public bool Contains(float o)
		{
			return Contains(new LiteralImpl(o));
		}
		public bool Contains(double o)
		{
			return Contains(new LiteralImpl(o));
		}
		public bool Contains(string o)
		{
			return Contains(new LiteralImpl(o));
		}
		public bool Contains(string o, string l)
		{
			return Contains(new LiteralImpl(o, l));
		}
		public bool Contains(object o)
		{
			return Contains(new LiteralImpl(o));
		}
		public IEnumerator GetEnumerator()
		{
			return ((ModelI)model).ListContainerMembers(this, iteratorFactory);
		}
		public int Count
		{
			get
			{
				return ((ModelI)model).ContainerSize(this);
			}
		}
		public Container Remove(Statement s)
		{
			int size = Count;
			Statement last = null;
			if(s.GetPredicate().GetOrdinal() == size)
				model.Remove(s);
			else
			{
				last = model.GetProperty(this, Vocabulary.RDF.li(size));
				s.Set(last.GetObject());
				model.Remove(last);
			}
			if(Count != (size - 1))
				throw new System.Exception("Assertion Failure");
			return this;
		}
		public Container Remove(int index, RDFNode o)
		{
			Remove(model.CreateStatement(this, Vocabulary.RDF.li(index), o));
			return this;
		}
	}// end ContainerImpl

		/// <summary>
	/// Implementation of the Alt interface
	/// </summary>
	public class AltImpl : ContainerImpl, Alt
	{
		public AltImpl(Model model) : base(model)
		{}
		public AltImpl(string uri, Model model) : base(uri, model)
		{}
		public AltImpl(Resource r, Model m) : base(r, model)
		{}

		public RDFNode GetDefault()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetObject();
			else
				throw new System.Exception("Alt has no default");
		}
		public Alt GetDefaultAlt()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetAlt();
			else
				throw new System.Exception("Alt has no default");
		}
		public Bag GetDefaultBag()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetBag();
			else
				throw new System.Exception("Alt has no default");
		}
		public bool GetDefaultBoolean()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetBoolean();
			else
				throw new System.Exception("Alt has no default");
		}
		public byte GetDefaultByte()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetByte();
			else
				throw new System.Exception("Alt has no default");
		}
		public char GetDefaultChar()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetChar();
			else
				throw new System.Exception("Alt has no default");
		}
		public double GetDefaultDouble()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetDouble();
			else
				throw new System.Exception("Alt has no default");
		}
		public float GetDefaultFloat()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetFloat();
			else
				throw new System.Exception("Alt has no default");
		}
		public int GetDefaultInteger()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetInteger();
			else
				throw new System.Exception("Alt has no default");
		}
		public string GetDefaultLanguage()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetLanguage();
			else
				throw new System.Exception("Alt has no default");
		}
		public long GetDefaultLong()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetLong();
			else
				throw new System.Exception("Alt has no default");
		}
		public Literal GetDefaultLiteral()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetLiteral();
			else
				throw new System.Exception("Alt has no default");
		}
		public object GetDefaultObject(ObjectF f)
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetObject(f);
			else
				throw new System.Exception("Alt has no default");
		}
		public Resource GetDefaultResource()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement.GetResource();
			else
				throw new System.Exception("Alt has no default");
		}
		public Resource GetDefaultResource(ResourceF f)
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetResource(f);
			else
				throw new System.Exception("Alt has no default");
		}
		public Seq GetDefaultSeq()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetSeq();
			else
				throw new System.Exception("Alt has no default");
		}
		public short GetDefaultShort()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetShort();
			else
				throw new System.Exception("Alt has no default");
		}
		public string GetDefaultString()
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				return GetDefaultStatement().GetString();
			else
				throw new System.Exception("Alt has no default");
		}
		public Alt SetDefault(bool o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(char o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(double o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(float o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(long o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(object o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(RDFNode o)
		{
			Statement stmt = GetDefaultStatement();
			if(stmt != null)
				model.Remove(stmt);
			model.Add(this, Vocabulary.RDF.Li(1), o);
			return this;
		}
		public Alt SetDefault(string o)
		{
			return SetDefault(new LiteralImpl(o));
		}
		public Alt SetDefault(string o, string l)
		{
			return SetDefault(new LiteralImpl(o, l));
		}
		public Resource Port(Model m)
		{
			if(model == m)
				return this;
			else
			{
				AltImpl r = new AltImpl(uri, m);
				r.id = id;
				return r;
			}
		}
		protected Statement GetDefaultStatement()
		{
			StmtEnumerator e = model.ListStatements(
				new SelectorImpl(this, Vocabulary.RDF.Li(1), (RDFNode)null));
			if(!e.MoveNext())
				return null;
			return e.Current;
		}
	}
	public interface NodeEnumeratorFactory
	{
		NodeEnumerator CreateEnumerator(IEnumerator e, object o, Container c);
	}// end NodeEnumeratorFactory
	public class ContNodeEnumeratorFactoryImpl : object, NodeEnumeratorFactory
	{
		public NodeEnumerator CreateEnumerator(IEnumerator e, object o, Container c)
		{
			return new ContNodeEnumeratorImpl(e, o, c);
		}
	}// end ContNodeEnumeratorFactoryImpl
	public class ContNodeEnumeratorImpl : object, NodeEnumerator
	{
		IEnumerator enumerator;
		object o;
		Statement stmt;
		Container cont;
		int size;
		int index = 0;
		int numDeleted = 0;
		ArrayList moved = new ArrayList();

		public ContNodeEnumeratorImpl(IEnumerator e, object o, Container c)
		{
			enumerator = e;
			this.o = o;
			this.cont = c;
			this.size = c.Count;
		}
		public bool MoveNext()
		{
			return enumerator.MoveNext();
		}
		public RDFNode Current
		{
			get
			{
				if(enumerator != null)
				{
					stmt = (Statement)enumerator.Current;
					index++;
					return stmt.GetObject();
				}
				else
					throw new System.Exception("Enumerator closed");
			}
		}
		public void Remove()
		{
			// NOT IMPLEMENTING UNTIL I ADD A REMOVE OPTION TO THE ENUMERATOR
		}
		public void Close()
		{
			// ClosableIterator stuff... figure this out!
			enumerator = null;
			o = null;
		}
	}// end ContNodeEnumeratorImpl
	
	public class NodeEnumeratorImpl : object, NodeEnumerator
	{
		IEnumerator enumerator;
		object o;

		public NodeEnumeratorImpl(IEnumerator e, object o)
		{
			enumerator = e;
			this.o = o;
		}
		public bool MoveNext()
		{
			if(enumerator != null)
				return enumerator.MoveNext();
			else
				throw new System.Exception("Enumerator not open");
		}
		public RDFNode Current
		{
			get
			{
				if(enumerator != null)
					return (RDFNode)enumerator.Current;
				else
					throw new System.Exception("Enumerator not open");
			}
		}
		public void Remove()
		{}
		public void Close()
		{
			enumerator = null;
			o = null;
		}
	}// end NodeEnumeratorImpl*/

	public class StmtEnumeratorImpl : object, StmtEnumerator
	{
		private ArrayList items;
		private int index = -1;
		
		public StmtEnumeratorImpl()
		{
			items = new ArrayList();
		}
		public StmtEnumeratorImpl(IEnumerator e)
		{
			items = new ArrayList();
			try
			{
				while(e.MoveNext())
					items.Add((Statement)e.Current);
			}
			catch(System.InvalidCastException)
			{
				throw new System.Exception("Enumerator does not contain Statements");
			}
		}
		public StmtEnumeratorImpl(ICollection c)
		{
			items = new ArrayList(c);
		}
		public Statement Current
		{
			get
			{// if index < 0, then MoveNext has not been called
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return (Statement)items[index];
			}
		}
		object IEnumerator.Current
		{
			get
			{
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return items[index];
			}
		}
		public bool MoveNext()
		{
			return (++index < items.Count) ? true : false;
		}
		/// <summary>
		/// This basically does nothing.
		/// </summary>
		public void Close()
		{}

		public void Reset()
		{
			index = -1;
		}
	}// end StmtEnumerator

	public class NsEnumeratorImpl : object, NsEnumerator
	{
		private ArrayList items = new ArrayList();
		private int index = -1;

		public NsEnumeratorImpl(IEnumerator e)
		{
			items = new ArrayList();
			try
			{
				while(e.MoveNext())
					items.Add((string)e.Current);
			}
			catch(System.InvalidCastException)
			{
				throw new System.Exception("Enumerator does not contain strings");
			}
		}
		public NsEnumeratorImpl(ICollection c)
		{
			items = new ArrayList(c);
		}
		public string Current
		{
			get
			{// if index < 0, then MoveNext has not been called
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return (string)items[index];
			}
		}
		object IEnumerator.Current
		{
			get
			{
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return items[index];
			}
		}
		public bool MoveNext()
		{
			return (++index < items.Count) ? true : false;
		}
		/// <summary>
		/// This basically does nothing.
		/// </summary>
		public void Close()
		{}

		public void Reset()
		{
			index = -1;
		}
	}// end NsEnumerator

	public class NodeEnumeratorImpl : object, NodeEnumerator
	{
		private ArrayList items = new ArrayList();
		private int index = -1;

		public NodeEnumeratorImpl(IEnumerator e)
		{
			items = new ArrayList();
			try
			{
				while(e.MoveNext())
					items.Add((RDFNode)e.Current);
			}
			catch(System.InvalidCastException)
			{
				throw new System.Exception("Enumerator does not contain RDFNodes");
			}
		}
		public NodeEnumeratorImpl(ICollection c)
		{
			items = new ArrayList(c);
		}
		public RDFNode Current
		{
			get
			{// if index < 0, then MoveNext has not been called
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return (RDFNode)items[index];
			}
		}
		object IEnumerator.Current
		{
			get
			{
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return items[index];
			}
		}
		public bool MoveNext()
		{
			return (++index < items.Count) ? true : false;
		}
		/// <summary>
		/// This basically does nothing.
		/// </summary>
		public void Close()
		{}

		public void Reset()
		{
			index = -1;
		}
	}// end NodeEnumerator

	public class ResEnumeratorImpl : object, ResEnumerator
	{
		private ArrayList items = new ArrayList();
		private int index = -1;

		public ResEnumeratorImpl(IEnumerator e)
		{
			items = new ArrayList();
			try
			{
				while(e.MoveNext())
					items.Add((Resource)e.Current);
			}
			catch(System.InvalidCastException)
			{
				throw new System.Exception("Enumerator does not contain Resources");
			}
		}
		public ResEnumeratorImpl(ICollection c)
		{
			items = new ArrayList(c);
		}
		public Resource Current
		{
			get
			{// if index < 0, then MoveNext has not been called
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return (Resource)items[index];
			}
		}
		object IEnumerator.Current
		{
			get
			{
				if(index < 0 || index >= items.Count)
					throw new System.InvalidOperationException();
				return items[index];
			}
		}
			public bool MoveNext()
		{
			return (++index < items.Count) ? true : false;
		}
		/// <summary>
		/// This basically does nothing.
		/// </summary>
		public void Close()
		{}

		public void Reset()
		{
			index = -1;
		}
	}// end ResEnumerator
}
