using System;
using System.Collections;
using BBN.RDF.Common;

namespace BBN.RDF
{
#if DYNAMIC
	/// <summary>
	/// Summary description for SourceModel.
	/// </summary>
	public interface SourceModel : Model
	{
		Model Add(Model m, Source source);
		Model Add(Statement s, Source source);
		Model Add(StmtEnumerator iter, Source source);
		Source GetSource(String uri);
		Model GetModelForSource(Source source);
		IEnumerator ListSources();
		StmtEnumerator ListStatementsOfSource(Source source);
		Model Read(System.IO.TextReader reader, string b, Source source);
		Model Read(System.IO.TextReader reader, string b, string lang, Source source);
		Model Read(System.IO.Stream stream, string b, Source source);
		Model Read(System.IO.Stream stream, string b, string lang, Source source);
		Model Read(String url, Source source);
		Model SetStatementSource(Statement s, Source source);
		Model SetStatementSource(StmtEnumerator iter, Source source);
		//Model Write(System.IO.StreamWriter writer, Source source);
		//Model Write(System.IO.StreamWriter writer, string lang, Source source);
		//Model Write(System.IO.StreamWriter writer, string lang, string b, Source source);
	}
#endif
}
