using System;

namespace BBN.RDF.Common
{
	/// <summary>
	/// 
	/// </summary>
	public class Util
	{
		/** Given a URI, determine the split point between the namespace part
		 * and the localname part.
		 *
	     * If there is no valid localname part then the length of the
	     * string is returned.
		 *
		 * @param uri
		 * @return the index of the first character of the localname
		 */
		public static int SplitNamespace(string uri)
		{
			char ch;
			int lg = uri.Length;
			if (lg == 0) return 0;
			int j;
			int i;
			for (i=lg-1; i>=0; i--) 
			{
				ch = uri[i];
				if ( (XMLChar.CHARS[ch] & XMLChar.MASK_NCNAME) == 0 )
					break;
			}
			for (j=i+1;j<lg;j++) 
			{
				ch = uri[j];
				if ((XMLChar.CHARS[ch] & XMLChar.MASK_NCNAME_START) != 0 )
					break;
			}
			return j;
		}

		/*
		public static int SplitNamespace(string uri)
		{
			char ch;
			if (uri.Length == 0) return 0;
			for (int i=uri.Length-1; i>=0; i--) 
			{
				ch = uri[i];
				if ( !(   ('a' <= ch && ch <= 'z')  // FIXME: this code does not fully implement the correct test
					||('A' <= ch && ch <= 'Z')
					||('0' <= ch && ch <= '9')
					|| ch == '-'
					|| ch == '_'
					|| ch == '.'
					|| ch == ':'
					)
					)
				{
					// found a character that cannot appear in a localname, so split here
					return i + 1;
				}
			}
			return 0;
		}
		*/
    

		public static string SubstituteStandardEntities(string s) 
		{        
			s = s.Replace("&", "&amp;");
			s = s.Replace("<", "&lt;");
			s = s.Replace(">", "&gt;");
			s = s.Replace("'", "&apos;");
			s = s.Replace("\t", "&#9;");
			s = s.Replace("\n", "&#xA;");
			s = s.Replace("\r", "&#xD;");
			s = s.Replace("\"", "&quot;");
			return s;
		}
        
		public static string Replace(string s, string oldString, string newString) 
		{
			string result = "";
			int length = oldString.Length;
			int pos = s.IndexOf(oldString);
			int lastPos = 0;
			while (pos >= 0) 
			{
				result = result + s.Substring(lastPos, pos) + newString;
				lastPos = pos + length;
				pos = s.IndexOf(oldString, lastPos);
			}
			return result + s.Substring(lastPos);
		}
	}

	// Jena 1.6.0 introduced GetProperty(...) which called System.getProperty(...) and suppressed any exceptions.
	// I don't think that is needed here.

}
