using System;
using BBN.RDF.Common;
using BBN.RDF;

namespace BBN.RDF.Vocabulary
{
	/// <summary>
	/// Summary description for Vocabulary.
	/// </summary>
	public class RDF
	{
		private static string uri = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
		private static string nAlt = "Alt";
		private static string nBag = "Bag";
		private static string nProperty = "Property";
		private static string nSeq = "Seq";
		private static string nStatement = "Statement";
		private static string nSubject = "subject";
		private static string nPredicate = "predicate";
		private static string nObject = "object";
		private static string nType = "type";
		private static string nValue = "value";

		public static Resource Alt = null;
		public static Resource Bag = null;
		public static Resource Property = null;
		public static Resource Seq = null;
		public static Resource Statement = null;
		public static Property subject = null;
		public static Property predicate = null;
		public static Property Object = null;
		public static Property type = null;
		public static Property Value = null;

		public static string GetURI()
		{
			return uri;
		}
		public static Property Li(int i)
		{
			return new PropertyImpl(uri, "_"+ i.ToString());
		}
		static RDF()
		{
			Alt = new ResourceImpl(uri + nAlt);
			Bag = new ResourceImpl(uri + nBag);
			Property = new ResourceImpl(uri + nProperty);
			Seq = new ResourceImpl(uri + nSeq);
			Statement = new ResourceImpl(uri + nStatement);
			type = new PropertyImpl(uri + nType);
			subject = new PropertyImpl(uri + nSubject);
			predicate = new PropertyImpl(uri + nPredicate);
			Object = new PropertyImpl(uri, nObject);
			Value = new PropertyImpl(uri, nValue);
		}
	}

	public class RDFS
	{
		private static string uri = "http://www.w3.org/2000/01/rdf-schema#";

		private static string   nClass    = "Class";
		private static string   nConstraintProperty = "ConstraintProperty";
		private static string   nContainer          = "Container";
		private static string   nContainerMembershipProperty = "ContainerMembershipProperty";
		private static string   nConstraintResource = "ConstraintResource";
		private static string   nLiteral            = "Literal";
		private static string   nResource           = "Resource";
		private static string   ncomment            = "comment";
		private static string   ndomain             = "domain";
		private static string   nlabel              = "label";
		private static string   nisDefinedBy        = "isDefinedBy";
		private static string   nrange              = "range";
		private static string   nseeAlso            = "seeAlso";
		private static string   nsubClassOf         = "subClassOf";
		private static string   nsubPropertyOf      = "subPropertyOf";

		public static Resource Class     = null;
		public static Resource ConstraintProperty  = null;
		public static Resource Container           = null;
		public static Resource ContainerMembershipProperty = null;
		public static Resource ConstraintResource  = null;
		public static Resource Literal             = null;
		public static Resource Resource            = null;
		public static Property comment             = null;
		public static Property domain              = null;
		public static Property label               = null;
		public static Property isDefinedBy         = null;
		public static Property range               = null;
		public static Property seeAlso             = null;
		public static Property subClassOf          = null;
		public static Property subPropertyOf       = null;

		public static string GetURI()
		{
			return uri;
		}
		public static Property Li(int i)
		{
			return new PropertyImpl(uri, "_"+ i.ToString());
		}
		static RDFS()
		{
			Class = new ResourceImpl(uri + nClass);
			ConstraintProperty = new ResourceImpl(uri + nConstraintProperty);
			Container = new ResourceImpl(uri + nContainer);
			ContainerMembershipProperty = new ResourceImpl(uri + nContainerMembershipProperty);
			ConstraintResource = new ResourceImpl(uri + nConstraintResource);
			Literal = new ResourceImpl(uri + nLiteral);
			Resource = new ResourceImpl(uri + nResource);
			comment = new PropertyImpl(uri + ncomment);
			domain = new PropertyImpl(uri + ndomain);
			label = new PropertyImpl(uri + nlabel);
			isDefinedBy = new PropertyImpl(uri + nisDefinedBy);
			range = new PropertyImpl(uri + nrange);
			seeAlso = new PropertyImpl(uri + nseeAlso);
			subClassOf = new PropertyImpl(uri + nsubClassOf);
			subPropertyOf = new PropertyImpl(uri + nsubPropertyOf);
		}
	}

}
